/*
    bcp (Blacky Copy)

    Dieses Programm kopiert Dateien oder Dev's in 512Byte Schritten
    und ignoriert jegliche Fehler. Wenn cp "cp: /dev/xx: I/O error"
    meldet mu bcp ran.

    ACHTUNG: Diese Programm kann Diskette und/oder Laufwerk zerstren!

    Zur Zerstrung von Laufwerk oder Medium kann es nur dann kommen
    wenn das Medium extrem viele defekte Sektoren hat und das Programm
    dann unnachgiebig Liest. Dadurch wird die Magnetschicht weiter
    zerstrt und die Schrei/Lesekpfe knnen durch Verunreinigungen
    zerstrt werden.

    Bei "normal" beschdigten Disketten klappt es einbandfrei. :-)

    Ich verdanke diesem Programm schon 2 gerettete Disketten Images
    und einem Defektes Laufwerk.

    Copyright (C) Andreas Hofmeier

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


    Name:     Andreas Hofmeier

    Adresse:  Stralsunder Strae 20
              28239 Bremen
              Germany

    Telefon:  +49-421-613793

    eMail:    An-H@An-H.de
              hofmeier@inbremen.de
              an-h@gmx.de

    Homepage: http://www.An-H.de/
	      hofmeier.home.pages.de
              http://www.LGut.uni-bremen.de/anh/

*/


#include <stdio.h>
#include "hofmeier.h"


char blacky_ver_info[] = "Blacky Copy v0.07 (c) Copyright 1998-2001 Andreas Hofmeier";


main(argc, argv)
  int argc;
  char *argv[];
{
  long i, ii, l;
  char c[512];
  FILE *q, *z;
  char x;

  allblackyintro(blacky_ver_info);

  if ((argc > 1) ? ((argv[1][0] == '-') && (toupper(argv[1][1]) == 'V')) : 0) {
    printf("%s\n\n", blacky_ver_info);
    printkinfo(stdout);
    exit(0);
  }

  if ((argc > 1) ? ((argv[1][0] == '-') && (toupper(argv[1][1]) == 'V')) : 0) {
    printf("%s\n\n", blacky_ver_info);
    printkinfo(stdout);
    exit(0);
  }

  if (argc < 3) {
    printf("Kopiert Dateien bzw. Block-Devs 1 zu 1 ohne auf Fehler zu auchten!\n");
    printf("... kann auch eingesetzt werden um eine unvollstndig kopierte Datei `zu ende' zu kopieren.\n");
    printf("Help:\n");
    printf("  bcp < <quelle> <ziel> [anzahl der Bytes] | -v >\n");
    printf("    -v: Version, Lizense\n");
    exit(1);
  }

  /* Bis */
  if (argc > 3) {
    ii = atol(argv[3]);
  } else {
    ii = filelen((char *) argv[1]);
    fprintf(stderr, "** Warning: No size specified! Autodetected: %u Bytes\n", ii);
  }
  /* Quelle (DEV) */
  if ((q = fopen(argv[1], "r")) == NULL) {
    fprintf(stderr, "** Error: Can't open specified sourcefile!\n");
    perror(argv[1]);
    exit(0);
  }
  /* Zeil */
  if ((i = filelen((char *) argv[2])) > 0) {
    if (i > ii) {
      fprintf(stderr, "** Warning: Targetfile is bigger or as sourcefile!\n");
    }
    if (i == ii) {
      fprintf(stderr, "** Warning: Targetfile and sourcefile have the same size!\n");
    }
    fprintf(stderr, "** The targetfile exists!\n");
    fprintf(stderr, "** [O]verwritten. (restart the copie session)\n");
    fprintf(stderr, "** [C]ontinue. (continue the copie session)\n");
    fprintf(stderr, "** e[X]it\n");
    scanf("%c", &x);
    if ((x != 'O') && (x != 'C')) {
      exit(1);
    }
  } else {
    x = 1;
  }
  if (x == 'O') {
    z = fopen(argv[2], "w");
    i = 0;
  }
  if (x == 'C') {
    z = fopen(argv[2], "a");
  }
  if (z == NULL) {
    fprintf(stderr, "** Error: Can't append or create specified targetfile!\n");
    perror(argv[2]);
    exit(1);
  }
  /* Blockweise copieren */
  printf("Reading...: xxxxxxxxxxxxxx");
  for (  ; i < ii;  ) {
    printf("%c%c%c%c%c%c%c%c%c%c%c%c%c%c%014d", 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, i);
    fflush(stdout);
    q = fopen(argv[1], "r");
    fseek(q, i, 1);
    memset(c, 0, 512);
    l = ((ii - i) >= 512) ? 512 : i;
    fread(c, l, 1, q);
    fclose(q);
    fwrite(c, l, 1, z);
    fflush(z);
    i += l;
  }
  printf("\nreaded %d Bytes.\n", i);
  ffsync(z);
  fclose(z);
  exit(0);
}
